#define PLUGIN "[ZP] Extra Items: dbar"
#define VERSION "1.0"
#define AUTHOR "NET"

#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <xs>
#include <cstrike>
#include <zombieplague> 

new const WEAPON_NATIVE[] = "zp_give_user_dbar";	// Натив на выдачу оружия

new g_itemid, g_dbar[33]

// Cvars
new cvar_dmgmultiplier, g_maxplayers, cvar_custommodel

new g_iDmg[33]

#define ITEM_NAME "Дpo6oвuk \rДвухстволка"
#define ITEM_COST 29

#define is_user_valid_alive(%1) (1 <= %1 <= g_maxplayers && is_user_alive(%1))

new FM_V_MODEL[64] = "models/zombie_plague/v_sh_dbar.mdl"
new FM_P_MODEL[64] = "models/zombie_plague/p_sh_dbar.mdl"
new FM_W_MODEL[64] = "models/w_xm1014.mdl"

/*---------------------------------------=[Plugin Register]=-----------------------------------------*/
public plugin_init()
{
	// Plugin Register
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	// Cvar Register
	cvar_dmgmultiplier = register_cvar("zp_dbar_dmg_multiplier", "2") //Damage Multiplier
	cvar_custommodel = register_cvar("zp_dbar_custom_model", "1") //Fire M4A1 Custom Model
	
	// Item Register
	g_itemid = zp_register_extra_item(ITEM_NAME, ITEM_COST, ZP_TEAM_HUMAN)
	
	// Events
	register_event("CurWeapon", "event_CurWeapon", "b", "1=1") 
	
	// Forwards
	register_forward(FM_PlayerPreThink, "fw_PlayerPreThink")
	register_forward(FM_CmdStart, "fw_CmdStart")
	register_forward(FM_SetModel, "fw_SetModel")
	
	// Hams
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage")
	RegisterHam(Ham_Item_AddToPlayer, "weapon_xm1014", "fw_AddToPlayer")
	
	g_maxplayers = get_maxplayers()
}

/*------------------------------------------=[Precaches]=--------------------------------------------*/
public plugin_precache() 
{
	// Models
	precache_model(FM_V_MODEL)
	precache_model(FM_P_MODEL)
	precache_model(FM_W_MODEL)
}

/*---------------------------------------=[Bug Prevention]=-----------------------------------------*/


public client_disconnected(id)
{
	g_dbar[id] = false
}

public zp_user_humanized_post(id, human)
{
	g_dbar[id] = false
}

public zp_user_infected_post(id)
{
	g_dbar[id] = false
}
public client_putinserver(id)
{
	g_dbar[id] = false
}

public plugin_natives()
{
	register_native(WEAPON_NATIVE, "give_dbar", 1);
}

public native_give_weapon_add(id)
{
	give_dbar(id)
}

public give_dbar(player)
{
	g_dbar[player] = true
	ham_strip_weapon(player, "weapon_xm1014")
	give_item(player, "weapon_xm1014")
	cs_set_user_bpammo(player, CSW_XM1014, 30)
}


public zp_extra_item_selected(player, itemid)
{
	if (itemid == g_itemid)
	{
		g_dbar[player] = true
		ham_strip_weapon(player, "weapon_xm1014")
		give_item(player, "weapon_xm1014")
		cs_set_user_bpammo(player, CSW_XM1014, 30)
	}
	return PLUGIN_CONTINUE
}

public event_CurWeapon(id)
{
	if (!is_user_valid_alive(id) || zp_get_user_zombie(id)) return PLUGIN_HANDLED
	
	new g_Weapon = read_data(2)
	if (g_Weapon == CSW_XM1014 && g_dbar[id] && get_pcvar_num(cvar_custommodel))
	{
		set_pev(id, pev_viewmodel2, FM_V_MODEL)
		set_pev(id, pev_weaponmodel2, FM_P_MODEL)
	}
	return PLUGIN_CONTINUE
}

/*-----------------------------------------=[Take Damage]=-------------------------------------------*/
public fw_TakeDamage(victim, inflictor, attacker, Float:damage, bitsDamageType)
{
	if(!(bitsDamageType & DMG_BULLET) || !is_user_connected(attacker) || !is_user_alive(victim) || !g_dbar[attacker])
		return HAM_IGNORED;

	if(get_user_weapon(attacker) != CSW_XM1014)
		return HAM_IGNORED;

	SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmgmultiplier));
	return HAM_IGNORED;
}
/*-----------------------------------------=[World Model]=-------------------------------------------*/
public fw_SetModel(entity, model[])
{
	
	static szClassName[33]; pev(entity, pev_classname, szClassName, charsmax(szClassName))
	if(!equal(szClassName, "weaponbox")) return FMRES_IGNORED;

	static owner, wpn
	owner = pev(entity, pev_owner)
	wpn = find_ent_by_owner(-1, "weapon_xm1014", entity)
	
	if(g_dbar[owner] && pev_valid(wpn))
	{
		g_dbar[owner] = false
		set_pev(wpn, pev_impulse, 324584)
		engfunc(EngFunc_SetModel, entity, FM_W_MODEL)
		
		return FMRES_SUPERCEDE
	}
	return FMRES_IGNORED
}

public fw_AddToPlayer(wpn, id)
{
	if(pev_valid(wpn) && is_user_connected(id) && pev(wpn, pev_impulse) == 324584)
	{
		g_dbar[id] = true
		set_pev(wpn, pev_impulse, 0)
		return HAM_HANDLED
	}
	return HAM_IGNORED
}

stock give_item(index, const item[]) 
{
	if (!equal(item, "weapon_", 7) && !equal(item, "ammo_", 5) && !equal(item, "item_", 5) && !equal(item, "tf_weapon_", 10))
		return 0;

	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, item));
	
	if (!pev_valid(ent))
		return 0;

	new Float:origin[3];
	pev(index, pev_origin, origin);
	set_pev(ent, pev_origin, origin);
	set_pev(ent, pev_spawnflags, pev(ent, pev_spawnflags) | SF_NORESPAWN);
	dllfunc(DLLFunc_Spawn, ent);

	new save = pev(ent, pev_solid);
	dllfunc(DLLFunc_Touch, ent, index);
	if (pev(ent, pev_solid) != save)
		return ent;

	engfunc(EngFunc_RemoveEntity, ent);

	return -1;
}

stock set_user_health(index, health) 
{
	health > 0 ? set_pev(index, pev_health, float(health)) : dllfunc(DLLFunc_ClientKill, index);
	return 1;
}

stock find_ent_by_owner(index, const classname[], owner, jghgtype = 0) {
	new strtype[11] = "classname", ent = index;
	switch (jghgtype) {
		case 1: strtype = "target";
		case 2: strtype = "targetname";
	}

	while ((ent = engfunc(EngFunc_FindEntityByString, ent, strtype, classname)) && pev(ent, pev_owner) != owner) {}

	return ent;
}

stock set_user_weapon_anim(id, anim)
{
	if(!is_user_valid_alive(id))
		return
	
	set_pev(id, pev_weaponanim, anim)
	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, {0, 0, 0}, id)
	write_byte(anim)
	write_byte(pev(id, pev_body))
	message_end()
}

//ZP50 Colorchat stock
stock zp_colored_print(target, const message[], any:...)
{
	static buffer[512], msg_SayText = 0
	if( !msg_SayText ) msg_SayText = get_user_msgid("SayText")
	
	// Send to everyone
	if (!target)
	{
		static player, maxplayers, argscount
		maxplayers = get_maxplayers()
		argscount = numargs()
		
		for (player = 1; player <= maxplayers; player++)
		{
			// Not connected
			if (!is_user_connected(player))
				continue;
			
			// Remember changed arguments
			static arg_index, changed_args[20], changedcount // [20] = max LANG_PLAYER occurencies	
			changedcount = 0
			
			// Replace LANG_PLAYER with player id
			for (arg_index = 2; arg_index < argscount; arg_index++)
			{
				if (getarg(arg_index) == LANG_PLAYER && arg_index + 1 < argscount)
				{
					// Check if next param string is a registered language translation
					static lang_key[64], arg_subindex
					arg_subindex = 0
					while ((lang_key[arg_subindex] = getarg(arg_index + 1, arg_subindex++))) { /* keep looping */ }
					if (GetLangTransKey(lang_key) != TransKey_Bad)
					{
						setarg(arg_index, 0, player)
						changed_args[changedcount++] = arg_index
						arg_index++ // skip next argument since we know it's a translation key
					}
				}
			}
			
			// Format message for player (+add ZP prefix)
			vformat(buffer, charsmax(buffer), message, 3)
			format(buffer, charsmax(buffer), "%s%s", "^x01[^x04ZP^x01] ", buffer)
			
			// Send it
			message_begin(MSG_ONE_UNRELIABLE, msg_SayText, _, player)
			write_byte(player)
			write_string(buffer)
			message_end()
			
			// Replace back player id's with LANG_PLAYER
			for (arg_index = 0; arg_index < changedcount; arg_index++)
				setarg(changed_args[arg_index], 0, LANG_PLAYER)
		}
	}
	// Send to specific target
	else
	{
		// Format message for player (+add ZP prefix)
		vformat(buffer, charsmax(buffer), message, 3)
		format(buffer, charsmax(buffer), "%s%s", "^x01[^x04ZP^x01] ", buffer)
		
		// Send it
		message_begin(MSG_ONE, msg_SayText, _, target)
		write_byte(target)
		write_string(buffer)
		message_end()
	}
}
stock ham_strip_weapon(id,weapon[])
{
    if(!equal(weapon,"weapon_",7)) return 0

    new wId = get_weaponid(weapon)
    if(!wId) return 0

    new wEnt
    while((wEnt = engfunc(EngFunc_FindEntityByString,wEnt,"classname",weapon)) && pev(wEnt,pev_owner) != id) {}
    if(!wEnt) return 0

    if(get_user_weapon(id) == wId) ExecuteHamB(Ham_Weapon_RetireWeapon,wEnt)

    if(!ExecuteHamB(Ham_RemovePlayerItem,id,wEnt)) return 0
    ExecuteHamB(Ham_Item_Kill,wEnt)

    set_pev(id,pev_weapons,pev(id,pev_weapons) & ~(1<<wId))

    return 1
} 
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1033\\ f0\\ fs16 \n\\ par }
*/
